{ lib ? import <nixpkgs/lib>
, common_amd64
}:
{
  overlays = common_amd64.overlays ++ [(final: prev: {

    platform_name = "am1i";

    kernel =
      final.lib.makeOverridable (prev.kernel.override {
        config = ./linux.config;
        buildTargets = [ "bzImage" ];
      }).overrideAttrs (a: {
        postInstall = (a.postInstall or "") + ''
          cp arch/x86_64/boot/bzImage $out/
        '';
      });

    console-device = "ttyS1";

    coreboot = final.lib.makeOverridable (prev.coreboot.override {
      iasl = final.iasl_20180531;
      payload = "${final.kernel}/bzImage";
      coreboot-toolchain = with final.coreboot-toolchain; [ x64 i386 ];
      fmap = ./custom.fmap;
      config = ./coreboot.config;
      uart-for-console =
        if      final.console-device == "ttyS0" then 0 # IDC ribbon-cable header on the motherboarod
        else if final.console-device == "ttyS1" then 1 # DB9 connector on rear I/O panel; omitted from some board variants
        else if final.console-device == null then null
        else throw "am1i currently supports only `null` and `ttyS{0,1}` for `console-device`";
    }).overrideAttrs (a: {
      /*
      postConfigure = (a.postConfigure or "") + ''
        echo CONFIG_VGA_BIOS_FILE=\"${./kabini-vgabios.rom}\" >> .config
      '';
      */
      postInstall = (a.postInstall or "") + ''
        cp src/mainboard/asus/am1i-a/cmos.layout $out/
      '';
    });
  })];
}

